package wtalk;

/*
 * Copyright (C) 2002 Matthew Wronka <wronkm@rpi.edu>
 * This file is released under the GNU General Public License version 2,
 * a version of which should have been provided along with this file.
 *
 * You might also find a copy at:
 * http://dmc.sf.net/files/gpl.txt
 * http://www.fsf.org/copyleft/gpl.html
 */

/**
 * Interface used by wtalk.WTalkProtocol to convey to the outer shell
 *	what messages are being recieved.
 *
 * @author Matthew Wronka <wronkm@rpi.edu>
 * @version 0
 */
public interface RMsgHandler{
	/**
	 * Message handler that receives informations on messages sent.
	 *
	 * @param to The target of a message.
	 * @param from The sender of a message; 
	 *	in the case where the local user has sent a message, this
	 *	may be null.
	 * @param data	The message data.
	 */
	public abstract void handle(String to, String from, String data);
}
