package wtalk.protocols.toc;


class TalkInternal {

	public void findPacket(Connection c, String buffer, Short bufferPosition, String outBuffer, final int frametype, Short l) {
		unsigned char ft;
		unsigned short sequence, length;

		if(bufferPosition < TocConstants.HEADER_LENGTH) // don't have whole header yet
			return; // NOT_FOUND;

		length = getLengthFromHeader(buffer);
		if (length > (8192 - TocConstants.HEADER_LENGTH)) {
			// disconnect c, PACKET_SIZE
			return; // DISCONNECT;
		}

		if (bufferPosition < length + TocConstants.HEADER_LENGTH)
			return; // NOT_FOUND;

		ft = getFrameTypeFromHeader(buffer);
		sequence = getSequenceFromHeader(buffer);

		outBuffer=buffer.substring(TocConstants.HEADER_LENGTH,TocConstants.HEADER_LENGTH+length);
		bufferPosition -= length + TocConstants.HEADER_LENGTH;
		buffer = buffer.substring(TocConstants.HEADER_LENGTH + length, TocConstants.HEADER_LENGTH+length+bufferPosition);
		l = length;

		if (frametype == SFLAP_FRAME_SIGNON)
			c.remoteSequence = sequence;
		else {
			if (sequence != ++(c.remoteSequence)) {
				// disconnect c, SEQUENE;
				return ; //disconnect
			}
		}

		if (ft == frametype)
			return ; // SUCCESS
		else
			return ; // WIERDPACKET
}

	private static unsigned short fillHeader(final byte[] header, final byte frametype, final unsigned short sequence, final unsigned short length){
		header[0] = '*';	// byte0, length 1, magic 42
		header[1] = frametype;	// byte1, length 1
		header[2] = sequence/256;	// byte 2, length 2, sequence number, network byte order
		header[3] = sequence%256;
		header[4] = length/256;	// byte 4, length 2, length, network byte order
		header[5] = length%256;
		return 6 + length;
}

	private static unsigned short fillSignon(final byte[] signon, final String username) {
		short length=username.length();
		signon[0] = '\0';	// byte 0, length 4, flap version (1)
		signon[1] = '\0';
		signon[2] = '\0';
		signon[3] = '\001';
		signon[4] = '\0';


};
